SystemOrganization addCategory: #'SqueakNxt-Core'!
SystemOrganization addCategory: #'SqueakNxt-Core-Constants'!
SystemOrganization addCategory: #'SqueakNxt-Core-Errors'!
SystemOrganization addCategory: #'SqueakNxt-Core-Protocol'!

Error subclass: #AlreadyPluggedDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core-Errors'!

Error subclass: #BusyPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core-Errors'!

Error subclass: #NotConnectedLego
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core-Errors'!

Error subclass: #UnpluggedDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core-Errors'!

Object subclass: #DirectCommandProtocol
	instanceVariableNames: 'port rawValues normalizedValues scaledValues batteryLevel lsBytesReady lsBytesRead lsRxData lsCurrentPort sensorTypes sensorModes askingProcess receivingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core-Protocol'!

!DirectCommandProtocol class methodsFor: 'constants-command types' stamp: 'Richo 3/10/2010 17:04'!
directCommandTelegramNoResponse
^16r80! !

!DirectCommandProtocol class methodsFor: 'constants-command types' stamp: 'Richo 3/10/2010 17:04'!
directCommandTelegramResponseRequired
^16r0! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:02'!
getBatteryLevel
^16rB! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:02'!
getCurrentProgramName
^16r11! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:02'!
getInputValues
^16r7! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:02'!
getOutputState
^16r6! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:02'!
keepAlive
^16rD! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:02'!
lsGetStatus
^16rE! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:02'!
lsRead
^16r10! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:02'!
lsWrite
^16rF! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:02'!
messageRead
^16r13! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:02'!
messageWrite
^16r9! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:03'!
playSoundFile
^16r2! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:03'!
playTone
^16r3! !

!DirectCommandProtocol class methodsFor: 'constants-command types' stamp: 'Richo 3/10/2010 17:04'!
replyTelegram
^16r2! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:03'!
resetInputScaledValue
^16r8! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:03'!
resetMotorPosition
^16rA! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:04'!
setInputMode
^16r5! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:04'!
setOutputState
^16r4! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:04'!
startProgram
^16r0! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:04'!
stopProgram
^16r1! !

!DirectCommandProtocol class methodsFor: 'constants-command headers' stamp: 'Richo 3/10/2010 17:04'!
stopSoundPlayback
^16rC! !

!DirectCommandProtocol class methodsFor: 'constants-command types' stamp: 'Richo 3/10/2010 17:04'!
systemCommandTelegramNoResponse
^16r81! !

!DirectCommandProtocol class methodsFor: 'constants-command types' stamp: 'Richo 3/10/2010 17:04'!
systemCommandTelegramResponseRequired
^16r1! !

!DirectCommandProtocol methodsFor: 'asking' stamp: 'Richo 12/7/2010 16:38'!
askForData
| type |
1 to: 4 do: [:i| 
	type := sensorTypes at: i.
	type = SensorType noSensor 
		ifFalse: [
			(type = SensorType lowspeed9V )
				ifTrue: [
					self askForUltrasonicSensorValuesOnPort: i.
					]
				ifFalse: [
					self askForRegularSensorValuesOnPort: i
					]
			]
	]! !

!DirectCommandProtocol methodsFor: 'asking' stamp: 'Richo 3/15/2010 11:43'!
askForRegularSensorValuesOnPort: aNumber
self dcGetInputValuesPort: aNumber - 1! !

!DirectCommandProtocol methodsFor: 'asking' stamp: 'Richo 3/15/2010 11:45'!
askForUltrasonicSensorValuesOnPort: aNumber 
	| portNumber t timeout |
	portNumber := aNumber - 1.
	self
		dcLowSpeedWritePort: portNumber
		txLength: 2
		rxLength: 1
		txData: (ByteArray with: 2 with: 66).
	self dcLowSpeedGetStatusPort: portNumber.
	t := Time millisecondClockValue.
	timeout := 100.
	[10 milliSeconds asDelay wait.
	(lsBytesReady at: aNumber)
			> 0
		or: [(Time millisecondsSince: t)
				> timeout]] whileFalse.
	self dcLowSpeedReadPort: portNumber! !

!DirectCommandProtocol methodsFor: 'accessing' stamp: 'Richo 3/15/2010 11:43'!
batteryLevel
self controlConnection.
^ self dcGetBatteryLevel! !

!DirectCommandProtocol methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 11:47'!
brakeMotorOnPort: aNumber 
	self controlConnection.
	self dcSetOutputStatePort: aNumber - 1
		power: 0
		mode: Mode brake + Mode motorOn
		regulation: RegulationMode regulationModeMotorSpeed
		turnRatio: 0
		runState: RunState motorRunStateRunning
		tachoLimit: 0! !

!DirectCommandProtocol methodsFor: 'connection' stamp: 'Richo 3/15/2010 10:51'!
connectOnPort: aString
	"If the port cant't be open it stores nil, this way we can know if it is
	connected by asking if port is nil.
	In windows we can't open a port using the port name, so I convert the
	string to an integer"
	port := SerialPort new baudRate: 9600;
				 parityType: 0;
				 dataBits: 8;
				 stopBitsType: 1.
	port := port
				openPort: (('COM*' match: aString)
						ifTrue: [aString asInteger]
						ifFalse: [aString]).
	self isConnected
		ifTrue: [self startSteppingProcesses]! !

!DirectCommandProtocol methodsFor: 'error control' stamp: 'Richo 3/15/2010 11:36'!
controlConnection
	self isConnected
		ifFalse: [^ NotConnectedLego signal: 'The Lego Nxt must be connected to a serial port']! !

!DirectCommandProtocol methodsFor: 'sensor connection' stamp: 'Richo 3/15/2010 11:36'!
correctTypeOf: aNxtSensor onPort: portNumber 
	self controlConnection.
	(sensorTypes at: portNumber)
			= aNxtSensor type
		ifFalse: [self plugSensor: aNxtSensor onPort: portNumber]! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:42'!
dcGetBatteryLevel
| msg |
msg := {self class directCommandTelegramResponseRequired .
		self class  getBatteryLevel .
		} asByteArray.
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:42'!
dcGetInputValuesPort: inputPort
| msg |
msg := {self class  directCommandTelegramResponseRequired .
		self class  getInputValues.
		inputPort.
		} asByteArray.
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:44'!
dcGetOutputStatePort: outputPort
| msg |
msg := {self class  directCommandTelegramResponseRequired .
		self class  getOutputState .
		outputPort.
		} asByteArray.
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:44'!
dcKeepAlive
| msg |
msg := {self class  directCommandTelegramResponseRequired  .
self class  keepAlive  } asByteArray.
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:44'!
dcLowSpeedGetStatusPort: port
| msg |
lsCurrentPort := port.
msg := {self class  directCommandTelegramResponseRequired.
		self class  lsGetStatus .
		port
		} asByteArray.
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:45'!
dcLowSpeedReadPort: port
| msg |
lsCurrentPort := port.
msg := {self class  directCommandTelegramResponseRequired.
		self class  lsRead .
		port.
		} asByteArray.
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:45'!
dcLowSpeedWritePort: port txLength: txDataLength rxLength: rxDataLength txData: txData
| msg |
lsCurrentPort := port.
lsBytesReady at: port + 1 put: 0.

msg := {self class  directCommandTelegramNoResponse .
		self class  lsWrite .
		port.
		txDataLength .
		rxDataLength.		
		} asByteArray , txData asByteArray.
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:46'!
dcPlaySoundFile: fileName withLoop: bool
"Sound files end with .rso"
| msg |
msg := {self class  directCommandTelegramNoResponse .
		self class  playSoundFile.
		bool ifTrue: [1] ifFalse: [0]
		} asByteArray,
		fileName asByteArray, (ByteArray with: 0).
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:46'!
dcPlayToneFrequency: freq duration: milliseconds
	| msg |
	msg := {self class  directCommandTelegramNoResponse.
			self class  playTone .
			(freq \\ 256).
			(freq // 256).
			(milliseconds \\ 256).
			(milliseconds // 256)
			 } asByteArray.
	self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:46'!
dcResetInputScaledValuePort: inputPort
| msg |
msg := {self class  directCommandTelegramNoResponse .
		self class  resetInputScaledValue .
		inputPort.
		} asByteArray.
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:46'!
dcResetMotorPositionPort: outputPort relative: aBoolean
| msg |
msg := {self class  directCommandTelegramNoResponse .
		self class  resetMotorPosition.
		outputPort.
		(aBoolean ifTrue: [1] ifFalse: [0])
		} asByteArray.
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:46'!
dcSetInputModePort: inputPort sensorType: sensorType sensorMode: sensorMode
"inputPort Range: 0-3"
| msg |
msg := {self class  directCommandTelegramNoResponse.
		self class  setInputMode.
		inputPort.
		sensorType.
		sensorMode} asByteArray.
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:47'!
dcSetOutputStatePort: outputPort power: power mode: mode regulation: regulation turnRatio: turnRatio runState: runState tachoLimit: tachoLimit
| msg limit tach1 tach2 tach3 tach4 tach5 |
	limit := tachoLimit.
	tach1 := limit // 4294967296.
	limit := limit \\ 4294967296.
	tach2 := limit // 16777216.
	limit := limit \\ 16777216.
	tach3 := limit // 65536.
	limit := limit \\ 65536.
	tach4 := limit // 256.
	tach5 := limit \\ 256.
msg := {self class  directCommandTelegramNoResponse .
		self class  setOutputState.
		outputPort.
		(power >= 0 ifTrue: [power] ifFalse: [256 + power]).
		mode.
		regulation.
		(turnRatio >= 0 ifTrue: [turnRatio] ifFalse: [256 + power]).
		runState.
		tach1.
		tach2.
		tach3.
		tach4.
		tach5
		} asByteArray.

self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:47'!
dcStartProgram: fileName
"Program files end with .rxe"
| msg |
msg := {self class  directCommandTelegramNoResponse .
		self class  startProgram} asByteArray ,
		fileName asByteArray, (ByteArray with: 0).
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:47'!
dcStopProgram
| msg |
msg := {self class  directCommandTelegramNoResponse .
		self class  stopProgram} asByteArray.
self send: msg! !

!DirectCommandProtocol methodsFor: 'direct commands' stamp: 'Richo 3/15/2010 11:47'!
dcStopSoundPlayback
| msg |
msg := {self class  directCommandTelegramNoResponse .
self class  stopSoundPlayback } asByteArray.
self send: msg! !

!DirectCommandProtocol methodsFor: 'connection' stamp: 'Richo 3/15/2010 11:37'!
disconnect
	self controlConnection; stopAllMotors; stopAllSensors; stopSteppingProcesses.
	port close.
	port := nil.
	self initializeVariables! !

!DirectCommandProtocol methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 11:47'!
floatMotorOnPort: aNumber 
	self controlConnection.
	self dcSetOutputStatePort: aNumber - 1
		power: 0
		mode: 0
		regulation: 0
		turnRatio: 0
		runState: 0
		tachoLimit: 0! !

!DirectCommandProtocol methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 11:44'!
getMotorValuesOnPort: aNumber 
	self controlConnection.
	^ self dcGetOutputStatePort: aNumber - 1! !

!DirectCommandProtocol methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 11:40'!
getPowerOnPort: aNumber 
	"Unfinished. Sorry"
	self controlConnection.
	^ 0! !

!DirectCommandProtocol methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 11:40'!
getRotationOnPort: aNumber 
	"Unfinished. Sorry"
	self controlConnection.
	^ -1! !

!DirectCommandProtocol methodsFor: 'sensor actions' stamp: 'Richo 3/15/2010 11:41'!
getSensorNormalizedValueOnPort: aNumber 
self controlConnection.
^normalizedValues at: aNumber! !

!DirectCommandProtocol methodsFor: 'sensor actions' stamp: 'Richo 3/15/2010 11:41'!
getSensorRawValueOnPort: aNumber 
	self controlConnection.
^rawValues at: aNumber! !

!DirectCommandProtocol methodsFor: 'sensor actions' stamp: 'Richo 3/15/2010 11:41'!
getSensorScaledValueOnPort: aNumber 
	self controlConnection.
^scaledValues at: aNumber! !

!DirectCommandProtocol methodsFor: 'sensor actions' stamp: 'Richo 3/15/2010 11:41'!
getSensorUltrasonicValueOnPort: aNumber 
	self controlConnection.
^lsRxData at: aNumber! !

!DirectCommandProtocol methodsFor: 'initialize-release' stamp: 'Richo 3/9/2010 18:05'!
initialize
self initializeVariables! !

!DirectCommandProtocol methodsFor: 'initialize-release' stamp: 'Richo 3/12/2010 17:56'!
initializeVariables

batteryLevel := 0.
rawValues := (Array new: 4 withAll: 0).
normalizedValues := (Array new: 4 withAll: 0).
scaledValues := (Array new: 4 withAll: 0).
lsCurrentPort := 0.
lsBytesReady := (Array new: 4 withAll: 0).
lsBytesRead := (Array new: 4 withAll: 0).
lsRxData := (Array new: 4 withAll: 0).
sensorTypes := (Array new: 4 withAll: 0).
sensorModes := (Array new: 4 withAll: 0).! !

!DirectCommandProtocol methodsFor: 'connection' stamp: 'Richo 3/9/2010 16:39'!
isConnected
^port notNil! !

!DirectCommandProtocol methodsFor: 'receiving' stamp: 'Richo 3/15/2010 11:00'!
parseGetBatteryLevelOn: data
"Returns voltage in millivolts"
batteryLevel := (data at: 6)  + ((data at: 7)  * 256).! !

!DirectCommandProtocol methodsFor: 'receiving' stamp: 'Richo 3/15/2010 10:23'!
parseGetInputValuesOn: data
| inputPort isValid isCalibrated sensorType sensorMode |
inputPort :=( data at: 6) asInteger + 1.
isValid := data at: 7.
isCalibrated := data at: 8.
sensorType := data at: 9.
sensorMode := data at: 10.
rawValues at: inputPort put: ((data at: 11)  + ((data at: 12)  * 256)).
normalizedValues  at: inputPort put:  ((data at: 13)  + ((data at: 14)  * 256)).
scaledValues  at: inputPort put:  ((data at: 15)  + ((data at: 16)  * 256))
 ! !

!DirectCommandProtocol methodsFor: 'receiving' stamp: 'Richo 3/10/2010 15:29'!
parseKeepAliveOn: data
"Does nothing for now"! !

!DirectCommandProtocol methodsFor: 'receiving' stamp: 'Richo 3/15/2010 11:00'!
parseLsGetStatusOn: data

lsBytesReady at: lsCurrentPort + 1 put: (data at: 6) ! !

!DirectCommandProtocol methodsFor: 'receiving' stamp: 'Richo 3/15/2010 10:32'!
parseLsReadOn: data


lsBytesRead at: lsCurrentPort + 1 put: (data at: 6) .
lsRxData at: lsCurrentPort + 1 put: (data at: 7)  + ((data at: 8)  * 256).! !

!DirectCommandProtocol methodsFor: 'actions' stamp: 'Richo 3/15/2010 11:48'!
playSoundFile: aString withLoop: aBoolean
	self controlConnection; dcPlaySoundFile: aString withLoop: aBoolean! !

!DirectCommandProtocol methodsFor: 'actions' stamp: 'Richo 3/15/2010 11:49'!
playTone: freqNumber duration: durationNumber
self controlConnection; dcPlayToneFrequency: freqNumber duration: durationNumber! !

!DirectCommandProtocol methodsFor: 'motor connections' stamp: 'Richo 3/12/2010 16:48'!
plugMotor: aNxtMotor onPort: aSmallInteger 
"Do nothing"! !

!DirectCommandProtocol methodsFor: 'sensor connection' stamp: 'Richo 3/15/2010 11:50'!
plugSensor: aNxtSensor onPort: aNumber 
| portNumber type mode |
self controlConnection.
portNumber := aNumber - 1.
type := aNxtSensor type.
mode := aNxtSensor mode.

self dcSetInputModePort: portNumber sensorType: type sensorMode: mode.
sensorTypes at: aNumber put: type.
sensorModes at: aNumber put: mode.! !

!DirectCommandProtocol methodsFor: 'receiving' stamp: 'Richo 3/15/2010 12:02'!
processInput

	self processInputOn: port readByteArray! !

!DirectCommandProtocol methodsFor: 'receiving' stamp: 'Richo 3/15/2010 11:34'!
processInputOn: data 
	| commandType commandHeader commandSize |
	data isEmpty
		ifTrue: [^ self].
	commandSize := data first.
	data size < (commandSize + 2)
		ifTrue: [^ self].
	commandType := data third.
	commandType = self class replyTelegram
		ifTrue: [
			"commandStatus := data fifth.
			commandStatus = 0 ifFalse: [(NxtError code: commandStatus) signal]."
			commandHeader := data fourth.
			commandHeader caseOf: {
				[self class getInputValues] -> [self parseGetInputValuesOn: data].
				[self class getBatteryLevel] -> [self parseGetBatteryLevelOn: data].
				[self class keepAlive] -> [self parseKeepAliveOn: data].
				[self class lsGetStatus] -> [self parseLsGetStatusOn: data].
				[self class lsRead] -> [self parseLsReadOn: data]}
				 otherwise: []].
	data size > (commandSize + 2)
		ifTrue: [	self
				processInputOn: (data allButFirst: commandSize + 2)]! !

!DirectCommandProtocol methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 11:50'!
resetMotorOnPort: portNumber relative: aBoolean 
	self controlConnection; dcResetMotorPositionPort: portNumber - 1 relative: aBoolean! !

!DirectCommandProtocol methodsFor: 'message sending' stamp: 'Richo 3/15/2010 11:51'!
send: aByteArray
	self controlConnection.
	port nextPutAll: (ByteArray with: aByteArray size with: 0) , aByteArray! !

!DirectCommandProtocol methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 11:56'!
setPower: powerNumber onPort: portNumber 
self controlConnection.
	self dcSetOutputStatePort: portNumber - 1
		power: powerNumber
		mode: Mode regulated + Mode motorOn
		regulation: RegulationMode regulationModeMotorSpeed
		turnRatio: 0
		runState: RunState motorRunStateRunning
		tachoLimit: 0! !

!DirectCommandProtocol methodsFor: 'stepping' stamp: 'Richo 12/7/2010 13:04'!
startAskingProcess
	askingProcess notNil
		ifTrue: [^ self].
	askingProcess := [| delay |
			delay := Delay forMilliseconds: self stepTime.
			[self askForData.
			delay wait] repeat] newProcess name: self asString , ' - Asking...';
				 priority: Processor highIOPriority;
				 resume ! !

!DirectCommandProtocol methodsFor: 'actions' stamp: 'Richo 3/15/2010 11:56'!
startProgram: aString 
	self controlConnection; dcStartProgram: aString! !

!DirectCommandProtocol methodsFor: 'stepping' stamp: 'Richo 12/7/2010 13:04'!
startReceivingProcess
	receivingProcess notNil
		ifTrue: [^ self].
	receivingProcess := [| delay |
			delay := Delay forMilliseconds: self stepTime.
			[self processInput.
			delay wait] repeat] newProcess name: self asString , ' - Receiving...';
				 priority: Processor highIOPriority;
				 resume ! !

!DirectCommandProtocol methodsFor: 'stepping' stamp: 'Richo 3/15/2010 10:51'!
startSteppingProcesses
	self startAskingProcess; startReceivingProcess! !

!DirectCommandProtocol methodsFor: 'stepping' stamp: 'Richo 3/15/2010 10:24'!
stepTime
	^ 10! !

!DirectCommandProtocol methodsFor: 'initialize-release' stamp: 'Richo 3/15/2010 12:04'!
stopAllMotors
	1
		to: 3
		do: [:i | self unplugMotorOnPort: i]! !

!DirectCommandProtocol methodsFor: 'initialize-release' stamp: 'Richo 3/15/2010 12:04'!
stopAllSensors
	1
		to: 4
		do: [:i | self unplugSensorOnPort: i]! !

!DirectCommandProtocol methodsFor: 'stepping' stamp: 'Richo 3/15/2010 10:53'!
stopAskingProcess
	askingProcess isNil
		ifTrue: [^ self].
	askingProcess terminate. 
	askingProcess := nil.! !

!DirectCommandProtocol methodsFor: 'actions' stamp: 'Richo 1/13/2011 17:05'!
stopPlayingSound
	self controlConnection; dcStopSoundPlayback! !

!DirectCommandProtocol methodsFor: 'actions' stamp: 'Richo 3/15/2010 11:58'!
stopProgram
	self controlConnection; dcStopProgram! !

!DirectCommandProtocol methodsFor: 'stepping' stamp: 'Richo 3/15/2010 10:53'!
stopReceivingProcess
	receivingProcess isNil
		ifTrue: [^ self].
	receivingProcess terminate. 
	receivingProcess := nil.! !

!DirectCommandProtocol methodsFor: 'stepping' stamp: 'Richo 3/15/2010 10:53'!
stopSteppingProcesses
self stopAskingProcess; stopReceivingProcess.! !

!DirectCommandProtocol methodsFor: 'motor connections' stamp: 'Richo 3/12/2010 16:48'!
unplugMotorOnPort: aSmallInteger 
"Do nothing"! !

!DirectCommandProtocol methodsFor: 'sensor connection' stamp: 'Richo 3/15/2010 11:58'!
unplugSensorOnPort: aNumber 
| portNumber type mode |
self controlConnection.
portNumber := aNumber - 1.
type := SensorType noSensor.
mode := SensorMode rawmode.

self dcSetInputModePort: portNumber sensorType: type sensorMode: mode.
sensorTypes at: aNumber put: type.
sensorModes at: aNumber put: mode.! !

Object subclass: #LegoNxt
	instanceVariableNames: 'protocol motorPorts sensorPorts testProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core'!

!LegoNxt commentStamp: 'Richo 12/7/2010 16:44' prior: 0!
I represent a Lego Mindstorms Nxt robot.
Below you'll find an example code:
---------------------------------------------------------------------------------------
| nxt motor sensor |
 
"Connection"
nxt := LegoNxt new.
nxt connectOnPort: 'COM6'.
nxt isConnected.
nxt disconnect. "Don't forget to disconnect me after finish using me"

"Motors"
motor := NxtMotor new.
nxt portA plug: motor.
motor power: 100.
motor brake.
nxt portA unplug.

"Sensors"
sensor := LightSensor new.
nxt port1 plug: sensor.
sensor rawValue.
sensor normalizedValue.
sensor scaledValue.
nxt port1 unplug.

"Other stuff"
nxt batteryLevel.
nxt playSoundFile: 'Woops.rso'.
nxt playTone: 783.
nxt startProgram: 'my program file.rxe'.
nxt stopProgram.
!

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 3/15/2010 12:06'!
batteryLevel
	^ protocol batteryLevel! !

!LegoNxt methodsFor: 'connection' stamp: 'Richo 3/15/2010 12:05'!
connectOnPort: portName 
	protocol connectOnPort: portName! !

!LegoNxt methodsFor: 'connection' stamp: 'Richo 3/15/2010 12:05'!
disconnect
protocol disconnect! !

!LegoNxt methodsFor: 'initializing' stamp: 'Richo 3/15/2010 12:05'!
initialize
	motorPorts := Array new: 3.
	1
		to: motorPorts size
		do: [:i | motorPorts
				at: i
				put: (MotorPort on: self portNumber: i)].
	sensorPorts := Array new: 4.
	1
		to: sensorPorts size
		do: [:i | sensorPorts
				at: i
				put: (SensorPort on: self portNumber: i)].
	protocol := DirectCommandProtocol new! !

!LegoNxt methodsFor: 'connection' stamp: 'Richo 3/15/2010 12:05'!
isConnected
	^ protocol  isConnected! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 12/7/2010 16:49'!
playSoundFile: aString 
	self playSoundFile: aString withLoop: false! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 12/7/2010 16:48'!
playSoundFile: aString withLoop: aBoolean
	protocol  playSoundFile: aString withLoop: aBoolean ! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 12/7/2010 16:49'!
playTone: freqNumber 
	self playTone: freqNumber duration: 200
! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 12/7/2010 16:49'!
playTone: freqNumber duration: milliseconds
	protocol playTone: freqNumber rounded duration: milliseconds rounded
! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:06'!
port1
	^ sensorPorts at: 1! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:06'!
port2
	^ sensorPorts at: 2! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:06'!
port3
	^ sensorPorts at: 3! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:06'!
port4
	^ sensorPorts at: 4! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 13:52'!
portA
^motorPorts at:1! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:05'!
portB
^motorPorts at: 2! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:06'!
portC
	^ motorPorts at: 3! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 3/15/2010 12:05'!
protocol 
	^ protocol ! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 3/15/2010 12:06'!
startProgram: aString 
	protocol  startProgram: aString! !

!LegoNxt methodsFor: 'testing' stamp: 'Richo 3/15/2010 11:25'!
startTestProcess
"Just for testing. Shows in the Transcript the input of all plugged sensors"
testProcess notNil ifTrue: [^self].
testProcess := [[
		10 milliSeconds asDelay wait.
		sensorPorts do: [:port |
			port isBusy ifTrue: [
				[Transcript show: port; nextPut: $:; space; show: port pluggedDevice rawValue; nextPutAll: '      '.] on: Error do: []
				].
			].
		Transcript cr.
		] repeat] forkNamed: 'LegoNxt testProcess'! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 1/13/2011 17:05'!
stopPlayingSound
	protocol stopPlayingSound
! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 3/15/2010 12:06'!
stopProgram
	protocol  stopProgram! !

!LegoNxt methodsFor: 'testing' stamp: 'Richo 3/15/2010 11:25'!
stopTestProcess
"Just for testing"
testProcess isNil ifTrue: [^self].
testProcess terminate.
testProcess := nil! !

Object subclass: #Mode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core-Constants'!

!Mode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:11'!
brake
	^ 2! !

!Mode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:11'!
motorOn
	^ 1! !

!Mode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:11'!
regulated
	^ 4! !

Object subclass: #NxtPluggableDevice
	instanceVariableNames: 'port nxt portNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core'!

!NxtPluggableDevice commentStamp: 'Richo 3/9/2010 15:23' prior: 0!
Abstract class. Represents a device that can be plugged on a LegoNxt (such as motors or sensors).

#plugOn: - Tries to plug on a given port.
#unplug - Unplugs the device from the nxt.

!

NxtPluggableDevice subclass: #NxtMotor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core'!

!NxtMotor commentStamp: 'Richo 3/9/2010 15:22' prior: 0!
I represent a motor that can be attached to the LegoNxt.

#brake - Stops the motor instantly.
#float - Stops the motor but keeps the inertia.
#power - Returns the current speed of the motor.
#power: - Lets you set the speed of the motor.
#resetRelative: - I don't know yet...
#rotation - Returns the angle of the motor (I don't know how to interpret this info yet)
!

!NxtMotor methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:22'!
brake
	self controlPlugging.
	port brake! !

!NxtMotor methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:22'!
float
		self controlPlugging.
	port float! !

!NxtMotor methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:22'!
power
		self controlPlugging.
	^ port getPower! !

!NxtMotor methodsFor: 'actions' stamp: 'Richo 11/11/2009 15:51'!
power: aNumber 
	"Motor | Port
	A | 0
	B | 1
	C | 2"
	"Power range: -100 100"
		self controlPlugging.
	port setPower: aNumber rounded! !

!NxtMotor methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:22'!
resetRelative: aBoolean 
	self controlPlugging.
	port resetRelative: aBoolean! !

!NxtMotor methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:22'!
rotation
	self controlPlugging.
	^ port getRotation! !

!NxtPluggableDevice methodsFor: 'error control' stamp: 'Richo 3/5/2009 16:17'!
controlPlugging
	self isPlugged
		ifFalse: [^ UnpluggedDevice signal: 'The ', self asString , ' must be plugged']! !

!NxtPluggableDevice methodsFor: 'plugging' stamp: 'Richo 2/16/2009 14:14'!
isPlugged
	^ port notNil! !

!NxtPluggableDevice methodsFor: 'plugging' stamp: 'Richo 3/5/2009 16:06'!
plugOn: aPort 
	self isPlugged
		ifTrue: [^ AlreadyPluggedDevice signal: 'The ', self asString, ' is already plugged'].
	thisContext client == aPort
		ifFalse: [aPort plug: self].
	port := aPort! !

!NxtPluggableDevice methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:15'!
port
^port! !

!NxtPluggableDevice methodsFor: 'printing' stamp: 'Richo 3/5/2009 16:05'!
printOn: aStream 
	aStream nextPutAll: self class asString! !

!NxtPluggableDevice methodsFor: 'plugging' stamp: 'Richo 3/5/2009 16:20'!
unplug
	"La conexin debe ser bidireccional"
	self isPlugged
		ifFalse: [^ UnpluggedDevice signal: 'The ', self asString , ' is already unplugged'].
	thisContext client = port
		ifFalse: [port unplug].
	port := nil! !

NxtPluggableDevice subclass: #NxtSensor
	instanceVariableNames: 'type mode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core'!

!NxtSensor commentStamp: 'Richo 3/9/2010 15:27' prior: 0!
Abstract class. Represents a sensor that can be plugged on a LegoNxt. It defines the necessary implementation to communicate with the nxt. Its subclasses must define the specific behavior as well as its internal data (type and mode).
Every sensor has a type (check SensorType) and a mode (check SensorMode).

#rawValue - Returns the sensor value without modifications.
#normalizedValue - Returns the sensor values in a 0-1023 range (depending on the sensor type).
#scaledValue - Returns the sensor values in a 0-100 range (depending on the sensor mode)!

NxtSensor subclass: #LightSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core'!

!LightSensor commentStamp: 'Richo 3/9/2010 15:18' prior: 0!
I represent a light sensor. I can be set as active (a little red lamp is on) or inactive (the sensor detects the ambient light)!

!LightSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:37'!
initialize
	self setInactive.
	mode:= SensorMode pctfullscalemode! !

!LightSensor methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 15:20'!
isActive
^self type = SensorType lightActive ! !

!LightSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:38'!
setActive
type := SensorType lightActive! !

!LightSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:38'!
setInactive
type := SensorType lightInactive! !

!NxtSensor methodsFor: 'accessing' stamp: 'Richo 10/17/2008 15:35'!
mode
	^ mode! !

!NxtSensor methodsFor: 'accessing-value' stamp: 'Richo 3/12/2010 16:58'!
normalizedValue

	self controlPlugging.
	port correctTypeOf: self.
	^ port getSensorNormalizedValue! !

!NxtSensor methodsFor: 'accessing-value' stamp: 'Richo 3/12/2010 16:58'!
rawValue

	self controlPlugging.
	port correctTypeOf: self.
	^ port getSensorRawValue! !

!NxtSensor methodsFor: 'accessing-value' stamp: 'Richo 3/12/2010 16:58'!
scaledValue
	self controlPlugging.
	port correctTypeOf: self.
	^ port getSensorScaledValue! !

!NxtSensor methodsFor: 'accessing' stamp: 'Richo 9/30/2008 16:15'!
type 
^type! !

NxtSensor subclass: #SoundSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core'!

!SoundSensor commentStamp: 'Richo 3/9/2010 15:29' prior: 0!
Represents a sound sensor. Can be set as audible or inaudible.
!

!SoundSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:37'!
initialize
	self setInaudible.
	mode:= SensorMode pctfullscalemode! !

!SoundSensor methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 17:16'!
isAudible
^self type = SensorType soundDba ! !

!SoundSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:38'!
setAudible
type :=  SensorType soundDba! !

!SoundSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:38'!
setInaudible
type := SensorType soundDb! !

NxtSensor subclass: #SwitchSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core'!

!SwitchSensor commentStamp: 'Richo 3/9/2010 15:29' prior: 0!
Represents a touch sensor!

!SwitchSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:38'!
initialize
type :=  SensorType switch.
	mode := SensorMode booleanmode! !

NxtSensor subclass: #UltrasonicSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core'!

!UltrasonicSensor commentStamp: 'Richo 3/9/2010 15:30' prior: 0!
Represents an ultrasonic sensor!

!UltrasonicSensor methodsFor: 'initialize' stamp: 'Richo 2/11/2009 13:38'!
initialize
	"When wanting to use the ultrasonic sensor, the sensor type should be
	set to LowSpeed_9V (the ultrasonic sensors is a digital sensor which
	need Lowspeed(I2C) communication and it also needs 9V. Sensor mode is
	not used when a digital sensor is used therefore this can be set to 0. If
	you want to use the ultrasonic sensor using direct command you first
	need to setup the sensor type correctly and the make a LSWRITE
	command and thereafter waiting for the communication to finish using
	the LSGETSTATUS and then finally make a LSREAD command."
type :=  SensorType lowspeed9V.
	mode := SensorMode rawmode! !

!UltrasonicSensor methodsFor: 'accessing-value' stamp: 'Richo 3/15/2010 10:46'!
rawValue
	self controlPlugging.
	port correctTypeOf: self.
	^ port getSensorUltrasonicValue! !

Object subclass: #Port
	instanceVariableNames: 'nxt pluggedDevice portNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core'!

!Port commentStamp: 'Richo 3/9/2010 15:28' prior: 0!
Abstract class. Represents the port in which devices (such as motors and sensors) can be plugged!

Port subclass: #MotorPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core'!

!MotorPort commentStamp: 'Richo 3/9/2010 15:29' prior: 0!
Represents the port in which you can connect motors.!

!MotorPort methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 12:06'!
brake
	nxt protocol brakeMotorOnPort: portNumber! !

!MotorPort methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 12:06'!
float

	nxt protocol floatMotorOnPort: portNumber! !

!MotorPort methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 12:06'!
getPower
^nxt protocol getPowerOnPort: portNumber! !

!MotorPort methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 12:06'!
getRotation
^nxt protocol getRotationOnPort: portNumber! !

!MotorPort methodsFor: 'printing' stamp: 'Richo 3/5/2009 15:52'!
printOn: aStream 

	portNumber = 1
		ifTrue: [aStream nextPutAll: 'Port A'. ^self].
	portNumber = 2
		ifTrue: [aStream nextPutAll: 'Port B'. ^self].
	portNumber = 3
		ifTrue: [aStream nextPutAll: 'Port C'.^self].
	aStream nextPutAll: 'Invalid port'
! !

!MotorPort methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 12:06'!
resetRelative: aBoolean
nxt protocol resetMotorOnPort: portNumber relative: aBoolean! !

!MotorPort methodsFor: 'plugging' stamp: 'Richo 3/15/2010 12:06'!
sendPlugCommandFor: aNxtMotor 
	nxt protocol plugMotor: aNxtMotor onPort: portNumber! !

!MotorPort methodsFor: 'plugging' stamp: 'Richo 3/15/2010 12:06'!
sendUnplugCommand
	nxt protocol unplugMotorOnPort: portNumber! !

!MotorPort methodsFor: 'motor actions' stamp: 'Richo 3/15/2010 12:06'!
setPower: aNumber 
	nxt protocol setPower: aNumber onPort: portNumber! !

!Port class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 15:01'!
new
self shouldNotImplement! !

!Port class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 15:27'!
on: aLegoNxt portNumber: aNumber 
	^ self basicNew setNxt: aLegoNxt portNumber: aNumber! !

!Port methodsFor: 'testing' stamp: 'Richo 2/16/2009 14:36'!
isBusy
^pluggedDevice notNil! !

!Port methodsFor: 'plugging' stamp: 'Richo 3/5/2009 15:46'!
plug: aNxtPluggableDevice 
	self isBusy
		ifTrue: [^ BusyPort signal: self asString , ' is busy'].
	aNxtPluggableDevice plugOn: self.
	pluggedDevice := aNxtPluggableDevice.
	self sendPlugCommandFor: aNxtPluggableDevice! !

!Port methodsFor: 'accessing' stamp: 'Richo 3/5/2009 16:01'!
pluggedDevice
	pluggedDevice isNil
		ifTrue: [^ UnpluggedDevice signal: 'Nothing is plugged in ', self asString].
	^ pluggedDevice! !

!Port methodsFor: 'accessing' stamp: 'Richo 2/16/2009 15:51'!
portNumber
^portNumber! !

!Port methodsFor: 'plugging' stamp: 'Richo 2/16/2009 15:24'!
sendPlugCommandFor: aNxtPluggableDevice 
	self subclassResponsibility! !

!Port methodsFor: 'plugging' stamp: 'Richo 2/16/2009 15:24'!
sendUnplugCommand
	self subclassResponsibility! !

!Port methodsFor: 'private' stamp: 'Richo 2/16/2009 15:27'!
setNxt: aLegoNxt portNumber: aNumber 
	nxt := aLegoNxt.
	portNumber := aNumber! !

!Port methodsFor: 'plugging' stamp: 'Richo 2/16/2009 15:23'!
unplug
	self pluggedDevice unplug.
	pluggedDevice := nil.
	self sendUnplugCommand! !

Port subclass: #SensorPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core'!

!SensorPort commentStamp: 'Richo 3/9/2010 15:29' prior: 0!
Represents the port in which you can connect sensors.!

!SensorPort methodsFor: 'sensor actions' stamp: 'Richo 3/15/2010 12:06'!
correctTypeOf: aNxtSensor 
	[nxt protocol correctTypeOf: aNxtSensor onPort: portNumber]
on: NotConnectedLego do: []! !

!SensorPort methodsFor: 'sensor actions' stamp: 'Richo 3/15/2010 12:06'!
getSensorNormalizedValue
^nxt protocol getSensorNormalizedValueOnPort: portNumber! !

!SensorPort methodsFor: 'sensor actions' stamp: 'Richo 3/15/2010 12:06'!
getSensorRawValue
^nxt protocol getSensorRawValueOnPort: portNumber! !

!SensorPort methodsFor: 'sensor actions' stamp: 'Richo 3/15/2010 12:06'!
getSensorScaledValue
^nxt protocol getSensorScaledValueOnPort: portNumber! !

!SensorPort methodsFor: 'sensor actions' stamp: 'Richo 3/15/2010 12:06'!
getSensorUltrasonicValue
^nxt protocol getSensorUltrasonicValueOnPort: portNumber! !

!SensorPort methodsFor: 'printing' stamp: 'Richo 3/5/2009 15:52'!
printOn: aStream 
	(portNumber between: 1 and: 4)
		ifTrue: [aStream nextPutAll: 'Port ' , portNumber asString]
		ifFalse: [
	aStream nextPutAll: 'Invalid port']! !

!SensorPort methodsFor: 'plugging' stamp: 'Richo 3/15/2010 12:06'!
sendPlugCommandFor: aNxtSensor 
	[nxt protocol plugSensor: aNxtSensor onPort: portNumber] on: NotConnectedLego do: []! !

!SensorPort methodsFor: 'plugging' stamp: 'Richo 3/15/2010 12:06'!
sendUnplugCommand
[	nxt protocol unplugSensorOnPort: portNumber] on: NotConnectedLego do: []! !

Object subclass: #RegulationMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core-Constants'!

!RegulationMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
regulationModeIdle
	^ 0! !

!RegulationMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
regulationModeMotorSpeed
	^ 1! !

!RegulationMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
regulationModeMotorSync
	^ 2! !

Object subclass: #RunState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core-Constants'!

!RunState class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
motorRunStateIdle
	^ 0! !

!RunState class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
motorRunStateRampdown
	^ 64! !

!RunState class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
motorRunStateRampup
	^ 16! !

!RunState class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
motorRunStateRunning
	^ 32! !

Object subclass: #SensorMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core-Constants'!

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:22'!
anglestepsmode
	^ 16rE0! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:21'!
booleanmode
	^ 16r20! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:22'!
celsiusmode
	^ 16rA0! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:22'!
fahrenheitmode
	^ 16rC0! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:23'!
modemask
	^ 16rE0! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 15:35'!
pctfullscalemode
"Porcentaje"
	^ 128! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:21'!
periodcountermode
	^ 16r60! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 15:36'!
rawmode
"De 0 a 1023"
	^ 0! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:23'!
slopemask
	^ 16r1F! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:21'!
transitioncntmode
	^ 16r40! !

Object subclass: #SensorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core-Constants'!

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
angle
	^ 4! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:16'!
custom
	^ 9! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
lightActive
	^ 5! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
lightInactive
	^ 6! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:16'!
lowspeed
	^ 16rA! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:16'!
lowspeed9V
	^ 11! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:16'!
noOfSensorTypes
	^ 12! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
noSensor
	^ 0! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
reflection
	^ 3! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:16'!
soundDb
^7! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 17:00'!
soundDba
"decibeles audibles"
	^ 8! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
switch
	^ 1! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
temperature
	^ 2! !

Object subclass: #UpdateFlags
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Core-Constants'!

!UpdateFlags commentStamp: 'Richo 10/28/2008 16:09' prior: 0!
UF_UPDATE_MODE (0x01), UF_UPDATE_SPEED (0x02),
UF_UPDATE_TACHO_LIMIT (0x04), UF_UPDATE_RESET_COUNT (0x08),
UF_UPDATE_PID_VALUES (0x10), UF_UPDATE_RESET_BLOCK_COUNT
(0x20), UF_UPDATE_RESET_ROTATION_COUNT (0x40),
UF_PENDING_UPDATES (0x80)!

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:09'!
mode
^1! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:11'!
pendingUpdates
^128
! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:10'!
pidValues
^16! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:10'!
resetBlockCount
^32! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:10'!
resetCount
^8! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:10'!
resetRotationCount
^64! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:09'!
speed
^2! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:09'!
tachoLimit
^4! !
